#ifndef GRAPH_HOPCROFT_WONG_H_
#define GRAPH_HOPCROFT_WONG_H_

#include <core/multipleDispatch.hpp>

#include <graph/Graph.h>
#include <graph/directed/DirectedGraph.h>
#include <graph/undirected/UndirectedGraph.h>

namespace graph
{

namespace isomorphism
{

// Decides isomorphism of triconnected planar graphs
class HopcroftWong : public std::DoubleDispatch<HopcroftWong, bool, graph::GraphBase, graph::GraphBase>
{
public:
	static bool hopcroftwong(const Graph &first, const Graph &second);

	static bool hopcroftwong(const UndirectedGraph &first, const UndirectedGraph &second);

};

} // namespace isomorphism

} // namespace graph

#endif // GRAPH_HOPCROFT_WONG_H_
