#ifndef GRAPH_ISOMORPHISM_H_
#define GRAPH_ISOMORPHISM_H_

#include <core/multipleDispatch.hpp>

#include <graph/Graph.h>
#include <graph/directed/DirectedGraph.h>
#include <graph/undirected/UndirectedGraph.h>

namespace graph
{

namespace isomorphism
{

class Isomorphism : public std::DoubleDispatch<Isomorphism, bool, graph::GraphBase, graph::GraphBase>
{
public:
	static bool isomorphism(const Graph &first, const Graph &second);

	static bool isomorphism(const DirectedGraph &first, const DirectedGraph &second);
	static bool isomorphism(const UndirectedGraph &first, const UndirectedGraph &second);
};

} // namespace isomorphism

} // namespace graph

#endif // GRAPH_ISOMORPHISM_H_
