/*
 * BottomOfTheStackSymbol.cpp
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#include "BottomOfTheStackSymbol.h"
#include <sax/FromXMLParserHelper.h>
#include "Symbol.h"
#include <object/Object.h>
#include <XmlApi.hpp>
#include "UniqueSymbol.h"

namespace alphabet {

BottomOfTheStackSymbol::BottomOfTheStackSymbol() {

}

SymbolBase* BottomOfTheStackSymbol::clone() const {
	return new BottomOfTheStackSymbol(*this);
}

SymbolBase* BottomOfTheStackSymbol::plunder() && {
	return new BottomOfTheStackSymbol(std::move(*this));
}

int BottomOfTheStackSymbol::compare(const BottomOfTheStackSymbol&) const {
	return 0;
}

void BottomOfTheStackSymbol::operator>>(std::ostream& out) const {
	out << "(BottomOfTheStackSymbol)";
}

BottomOfTheStackSymbol::operator std::string () const {
	return "T";
}

BottomOfTheStackSymbol BottomOfTheStackSymbol::BOTTOM_OF_THE_STACK = BottomOfTheStackSymbol ( );
Symbol BottomOfTheStackSymbol::BOTTOM_OF_THE_STACK_SYMBOL = Symbol ( BottomOfTheStackSymbol ( ) );

const std::string BottomOfTheStackSymbol::XML_TAG_NAME = "BottomOfTheStackSymbol";

BottomOfTheStackSymbol BottomOfTheStackSymbol::parse(std::deque<sax::Token>::iterator& input) {
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::START_ELEMENT, BottomOfTheStackSymbol::XML_TAG_NAME);
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::END_ELEMENT, BottomOfTheStackSymbol::XML_TAG_NAME);
	return BottomOfTheStackSymbol();
}

void BottomOfTheStackSymbol::compose(std::deque<sax::Token>& out) const {
	out.emplace_back(BottomOfTheStackSymbol::XML_TAG_NAME, sax::Token::TokenType::START_ELEMENT);
	out.emplace_back(BottomOfTheStackSymbol::XML_TAG_NAME, sax::Token::TokenType::END_ELEMENT);
}

SymbolBase* BottomOfTheStackSymbol::next() const {
	return new UniqueSymbol(Symbol(*this), primitive::Integer(0));
}

SymbolBase* BottomOfTheStackSymbol::inc() && {
	return new UniqueSymbol(Symbol(std::move(*this)), primitive::Integer(0));
}

} /* namespace alphabet */

namespace alib {

auto bottomOfTheStackSymbolParserRegister = xmlApi<alphabet::Symbol>::ParserRegister<alphabet::BottomOfTheStackSymbol>();
auto bottomOfTheStackSymbolParserRegister2 = xmlApi<alib::Object>::ParserRegister<alphabet::BottomOfTheStackSymbol>();

} /* namespace alib */
