/*
 * RankedTreeWrapper.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Jan Travnicek
 */

#include "RankedTreeWrapper.h"
#include <XmlApi.hpp>

namespace tree {

const std::set < alphabet::RankedSymbol > & RankedTreeWrapper::getAlphabet ( ) const {
	return this->getData ( ).getAlphabet ( );
}

void RankedTreeWrapper::extendAlphabet ( const std::set < alphabet::RankedSymbol > & symbols ) {
	this->getData ( ).extendAlphabet ( symbols );
}

const std::string RankedTreeWrapper::XML_TAG_NAME_REF = "RankedTreeWrapperRef";

} /* namespace tree */

namespace alib {

auto RankedTreeWrapperDeleter = xmlApi < tree::RankedTreeWrapper >::InputContextDeleter ( );

}
